【leetcode】278. First Bad Version

題目:
You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, …, n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.


思路:
二分查找,API調用次數最少。


代碼實現:
由於已經理解透徹二分查找算法,所以submit一次就過了。

// The API isBadVersion is defined for you.
// bool isBadVersion(int version);

class Solution {
public:
    int firstBadVersion(int n) {
        if (n == 1){
            return isBadVersion(n);
        }
        
        int begin = 1;
        int end = n;
        int mid;

        while (begin < end) {
            mid = begin + (end - begin) / 2;
            if (isBadVersion(mid) == false) {
                begin = mid + 1;
            }
            else {
                end = mid;
            }
        }
        
        return begin;
    }
};

在這裏插入圖片描述

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章